import { DragDropDriver, MouseClickDriver, MouseMoveDriver, ViewportResizeDriver, ViewportScrollDriver, KeyboardDriver, } from './drivers';
import { useCursorEffect, useViewportEffect, useDragDropEffect, useSelectionEffect, useKeyboardEffect, useAutoScrollEffect, useWorkspaceEffect, useFreeSelectionEffect, useContentEditableEffect, } from './effects';
import { SelectNodes, SelectAllNodes, SelectSameTypeNodes, DeleteNodes, CopyNodes, PasteNodes, UndoMutation, RedoMutation, CursorSwitchSelection, PreventCommandX, SelectPrevNode, SelectNextNode, } from './shortcuts';
export var DEFAULT_EFFECTS = [
    useCursorEffect,
    useViewportEffect,
    useDragDropEffect,
    useSelectionEffect,
    useKeyboardEffect,
    useAutoScrollEffect,
    useWorkspaceEffect,
    useFreeSelectionEffect,
    useContentEditableEffect,
];
export var DEFAULT_DRIVERS = [
    DragDropDriver,
    MouseClickDriver,
    MouseMoveDriver,
    ViewportResizeDriver,
    ViewportScrollDriver,
    KeyboardDriver,
];
export var DEFAULT_SHORTCUTS = [
    PreventCommandX,
    SelectNodes,
    SelectAllNodes,
    SelectSameTypeNodes,
    DeleteNodes,
    CopyNodes,
    PasteNodes,
    SelectPrevNode,
    SelectNextNode,
    UndoMutation,
    RedoMutation,
    CursorSwitchSelection,
];
