"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SelectNextNode = exports.SelectPrevNode = void 0;
var models_1 = require("../models");
exports.SelectPrevNode = new models_1.Shortcut({
    codes: [
        [models_1.KeyCode.Up],
        [models_1.KeyCode.PageUp],
        [models_1.KeyCode.ArrowUp],
        [models_1.KeyCode.Left],
        [models_1.KeyCode.LeftWindowKey],
        [models_1.KeyCode.ArrowLeft],
    ],
    handler: function (context) {
        var operation = context === null || context === void 0 ? void 0 : context.workspace.operation;
        if (operation) {
            var tree = operation.tree;
            var selection = operation.selection;
            var lastNode = tree.findById(selection.last);
            if (lastNode) {
                var previousNode = lastNode.previous;
                if (previousNode) {
                    selection.select(previousNode);
                }
                else if (lastNode.parent) {
                    selection.select(lastNode.parent);
                }
                else {
                    selection.select(lastNode.lastChild);
                }
            }
        }
    },
});
exports.SelectNextNode = new models_1.Shortcut({
    codes: [
        [models_1.KeyCode.Down],
        [models_1.KeyCode.PageDown],
        [models_1.KeyCode.ArrowDown],
        [models_1.KeyCode.Right],
        [models_1.KeyCode.RightWindowKey],
        [models_1.KeyCode.ArrowRight],
    ],
    handler: function (context) {
        var operation = context === null || context === void 0 ? void 0 : context.workspace.operation;
        if (operation) {
            var tree = operation.tree;
            var selection = operation.selection;
            var lastNode = tree.findById(selection.last);
            if (lastNode) {
                var nextNode = lastNode.next;
                if (nextNode) {
                    selection.select(nextNode);
                }
                else if (lastNode.parent) {
                    selection.select(lastNode.parent);
                }
                else {
                    selection.select(lastNode.firstChild);
                }
            }
        }
    },
});
